'use strict';

exports.__esModule = true;
exports.default = createScanner;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _merge = require('../utils/merge');

var _merge2 = _interopRequireDefault(_merge);

var _parsers = require('../parsers');

var _parsers2 = _interopRequireDefault(_parsers);

var _readFile = require('../utils/readFile');

var _readFile2 = _interopRequireDefault(_readFile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('node-config-loader:createScanner:debug');

function createScanner() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var merge = opts.merge || _merge2.default;
    var parser = opts.parser || _parsers2.default;
    var readFile = opts.readFile || _readFile2.default;
    var rf = function rf(file) {
        return readFile(file);
    };

    return function scanner(files) {
        debug('files: %s', files.join('\n'));
        var strToData = function strToData(datas) {
            return Promise.all(datas.map(function (contents, i) {
                return parser({
                    contents: contents,
                    path: files[i]
                });
            }));
        };

        return Promise.all(files.map(rf)).then(strToData).then(merge);
    };
}
//# sourceMappingURL=createScanner.js.map