'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = merge;
function mergeToTarget(target, src, pushKeys) {
    var keys = Object.keys(src);
    for (var i = 0, j = keys.length; i < j; i++) {
        var key = keys[i];
        var val = src[key];
        if (key === '__push__') {
            continue;
        }
        if (val !== undefined) {
            if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && val !== null) {
                if (Array.isArray(val)) {
                    var arr = pushKeys.indexOf(key) !== -1 ? target[key] || [] : [];
                    target[key] = arr.concat(val);
                } else {
                    if (!target[key]) {
                        target[key] = {};
                    }
                    mergeToTarget(target[key], val, pushKeys);
                }
            } else {
                target[key] = val;
            }
        }
    }

    return target;
}

function merge(objects) {
    var dest = {};
    var pushKeys = objects[0].__push__ || [];
    for (var i = 0, j = objects.length; i < j; i++) {
        var obj = objects[i];
        mergeToTarget(dest, obj, pushKeys);
    }

    return dest;
}
//# sourceMappingURL=merge.js.map