"use strict";

exports.__esModule = true;
exports.default = nodePromisify;
function nodePromisify(fn) {
    var self = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    return function promised() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return new Promise(function (resolve, reject) {
            function cb(err, data) {
                if (err) {
                    reject(err);
                } else {
                    resolve(data);
                }
            }
            fn.apply(self, args.concat([cb]));
        });
    };
}
//# sourceMappingURL=nodePromisify.js.map